   PROGRAM



   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABFUZZY.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE

   MAP
     MODULE('Windows API')
SystemParametersInfo PROCEDURE (LONG uAction, LONG uParam, *? lpvParam, LONG fuWinIni),LONG,RAW,PROC,PASCAL,DLL(TRUE),NAME('SystemParametersInfoA')
     END
     MODULE('EMAILBC.CLW')
DctInit     PROCEDURE                                      ! Initializes the dictionary definition module
DctKill     PROCEDURE                                      ! Kills the dictionary definition module
     END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('EMAIL001.CLW')
Main                   PROCEDURE   !Clarion 5 Quick Application for E:\winapps\autoshop\Email.DCT
     END
     MODULE('SENDMAIL.CLW')
SendMail               FUNCTION(STRING ToAddress, STRING Subject, STRING Body, <STRING FileName>, <BYTE ReturnRecip>, <ULONG Flags> ),ULONG   !Send an email message
GetMapiErrorText       FUNCTION(LONG ErrorNumber),STRING   !Returns an error message for a given MAPI error number
     END
     INCLUDE('emaildef.inc', 'Map')
   END

FromEmail            STRING(255)
MSG:ReturnReceiptRequested LONG
MSG:Body             CSTRING(800)
MSG:Subject          CSTRING(50)
MSG:FileToAttach     CSTRING(128)
SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'

address              FILE,DRIVER('TOPSPEED'),PRE(ADD),CREATE,BINDABLE,THREAD
KeyName                  KEY(ADD:Name),NOCASE,OPT
Record                   RECORD,PRE()
Name                        STRING(30)
email                       STRING(50)
                         END
                     END                       


Access:address       &FileManager,THREAD                   ! FileManager for address
Relate:address       &RelationManager,THREAD               ! RelationManager for address

FuzzyMatcher         FuzzyClass                            ! Global fuzzy matcher
GlobalErrorStatus    ErrorStatusClass,THREAD
GlobalErrors         ErrorClass                            ! Global error manager
INIMgr               CLASS(INIClass)                       ! Global non-volatile storage manager
Fetch                  PROCEDURE(),DERIVED                 ! Method added to host embed code
Update                 PROCEDURE(),DERIVED                 ! Method added to host embed code
                     END

GlobalRequest        BYTE(0),THREAD                        ! Set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE(0),THREAD                        ! Set to the response from the form
VCRRequest           LONG(0),THREAD                        ! Set to the request from the VCR buttons

Dictionary           CLASS,THREAD
Construct              PROCEDURE
Destruct               PROCEDURE
                     END

lCurrentFDSetting    LONG                                  ! Used by window frame dragging
lAdjFDSetting        LONG                                  ! ditto

  CODE
  GlobalErrors.Init(GlobalErrorStatus)
  FuzzyMatcher.Init                                        ! Initilaize the browse 'fuzzy matcher'
  FuzzyMatcher.SetOption(MatchOption:NoCase, 1)            ! Configure case matching
  FuzzyMatcher.SetOption(MatchOption:WordOnly, 0)          ! Configure 'word only' matching
  INIMgr.Init('email.INI', NVD_INI)                        ! Configure INIManager to use INI file
  DctInit
  SystemParametersInfo (38, 0, lCurrentFDSetting, 0)       ! Configure frame dragging
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 0, lAdjFDSetting, 3)
  END
  Main
  INIMgr.Update
  IF lCurrentFDSetting = 1
    SystemParametersInfo (37, 1, lAdjFDSetting, 3)
  END
  INIMgr.Kill                                              ! Destroy INI manager
  FuzzyMatcher.Kill                                        ! Destroy fuzzy matcher


Dictionary.Construct PROCEDURE

  CODE
  IF THREAD()<>1
     DctInit()
  END


Dictionary.Destruct PROCEDURE

  CODE
  DctKill()


INIMgr.Fetch PROCEDURE

  CODE
  FromEmail = SELF.TryFetch('Preserved','FromEmail')       ! Resore ' preserved variable' from non-volatile store
  MSG:Body = SELF.TryFetch('Preserved','MSG:Body')         ! Resore ' preserved variable' from non-volatile store
  MSG:Subject = SELF.TryFetch('Preserved','MSG:Subject')   ! Resore ' preserved variable' from non-volatile store
  MSG:FileToAttach = SELF.TryFetch('Preserved','MSG:FileToAttach') ! Resore ' preserved variable' from non-volatile store
  PARENT.Fetch


INIMgr.Update PROCEDURE

  CODE
  PARENT.Update
  SELF.Update('Preserved','FromEmail',FromEmail)           ! Save 'preserved variable' in non-volatile store
  SELF.Update('Preserved','MSG:Body',MSG:Body)             ! Save 'preserved variable' in non-volatile store
  SELF.Update('Preserved','MSG:Subject',MSG:Subject)       ! Save 'preserved variable' in non-volatile store
  SELF.Update('Preserved','MSG:FileToAttach',MSG:FileToAttach) ! Save 'preserved variable' in non-volatile store

