

   MEMBER('email.clw')                                     ! This is a MEMBER module


   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('EMAIL001.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('EMAIL002.INC'),ONCE        !Req'd for module callout resolution
                     END


Main PROCEDURE                                             ! Generated from procedure template - Frame

FilesOpened          BYTE                                  !
AppFrame             APPLICATION('Email Demo Application'),AT(,,400,240),FONT('MS Sans Serif',8,,),STATUS(-1,80,120,45),SYSTEM,MAX,RESIZE,IMM
                       MENUBAR
                         MENU('&File'),USE(?FileMenu)
                           ITEM('&Print Setup ...'),USE(?PrintSetup),MSG('Setup printer'),STD(STD:PrintSetup)
                           ITEM,SEPARATOR
                           ITEM('E&xit'),USE(?Exit),MSG('Exit this application'),STD(STD:Close)
                         END
                         MENU('&Edit'),USE(?EditMenu)
                           ITEM('Cu&t'),USE(?Cut),MSG('Remove item to Windows Clipboard'),STD(STD:Cut)
                           ITEM('&Copy'),USE(?Copy),MSG('Copy item to Windows Clipboard'),STD(STD:Copy)
                           ITEM('&Paste'),USE(?Paste),MSG('Paste contents of Windows Clipboard'),STD(STD:Paste)
                         END
                         MENU('&Browse'),USE(?BrowseMenu)
                           ITEM('Browse the address file'),USE(?Browseaddress),MSG('Browse address')
                         END
                         MENU('&Window'),USE(?WindowMenu),MSG('Create and Arrange windows'),STD(STD:WindowList)
                           ITEM('T&ile'),USE(?Tile),MSG('Make all open windows visible'),STD(STD:TileWindow)
                           ITEM('&Cascade'),USE(?Cascade),MSG('Stack all open windows'),STD(STD:CascadeWindow)
                           ITEM('&Arrange Icons'),USE(?Arrange),MSG('Align all window icons'),STD(STD:ArrangeIcons)
                         END
                         MENU('&Help'),USE(?HelpMenu),MSG('Windows Help')
                           ITEM('&Contents'),USE(?Helpindex),MSG('View the contents of the help file'),STD(STD:HelpIndex)
                           ITEM('&Search for Help On...'),USE(?HelpSearch),MSG('Search for help on a subject'),STD(STD:HelpSearch)
                           ITEM('&How to Use Help'),USE(?HelpOnHelp),MSG('How to use Windows Help'),STD(STD:HelpOnHelp)
                         END
                       END
                       TOOLBAR,AT(0,0,400,22)
                         BUTTON,AT(4,2,16,14),USE(?Toolbar:Top,Toolbar:Top),DISABLE,FLAT,TIP('Go to the First Page'),ICON('VCRFIRST.ICO')
                         BUTTON,AT(20,2,16,14),USE(?Toolbar:PageUp,Toolbar:PageUp),DISABLE,FLAT,TIP('Go to the Prior Page'),ICON('VCRPRIOR.ICO')
                         BUTTON,AT(36,2,16,14),USE(?Toolbar:Up,Toolbar:Up),DISABLE,FLAT,TIP('Go to the Prior Record'),ICON('VCRUP.ICO')
                         BUTTON,AT(52,2,16,14),USE(?Toolbar:Locate,Toolbar:Locate),DISABLE,FLAT,TIP('Locate record'),ICON('FIND.ICO')
                         BUTTON,AT(68,2,16,14),USE(?Toolbar:Down,Toolbar:Down),DISABLE,FLAT,TIP('Go to the Next Record'),ICON('VCRDOWN.ICO')
                         BUTTON,AT(84,2,16,14),USE(?Toolbar:PageDown,Toolbar:PageDown),DISABLE,FLAT,TIP('Go to the Next Page'),ICON('VCRNEXT.ICO')
                         BUTTON,AT(100,2,16,14),USE(?Toolbar:Bottom,Toolbar:Bottom),DISABLE,FLAT,TIP('Go to the Last Page'),ICON('VCRLAST.ICO')
                         BUTTON,AT(120,2,16,14),USE(?Toolbar:Select,Toolbar:Select),DISABLE,FLAT,TIP('Select This Record'),ICON('MARK.ICO')
                         BUTTON,AT(136,2,16,14),USE(?Toolbar:Insert,Toolbar:Insert),DISABLE,FLAT,TIP('Insert a New Record'),ICON('INSERT.ICO')
                         BUTTON,AT(152,2,16,14),USE(?Toolbar:Change,Toolbar:Change),DISABLE,FLAT,TIP('Edit This Record'),ICON('EDIT.ICO')
                         BUTTON,AT(168,2,16,14),USE(?Toolbar:Delete,Toolbar:Delete),DISABLE,FLAT,TIP('Delete This Record'),ICON('DELETE.ICO')
                         BUTTON,AT(188,2,16,14),USE(?Toolbar:History,Toolbar:History),DISABLE,FLAT,TIP('Previous value'),ICON('DITTO.ICO')
                         BUTTON,AT(204,2,16,14),USE(?Toolbar:Help,Toolbar:Help),DISABLE,FLAT,TIP('Get Help'),ICON('HELP.ICO')
                       END
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It's called after the window open
!|
!---------------------------------------------------------------------------
Menu::FileMenu ROUTINE                                     ! Code for menu items on ?FileMenu
Menu::EditMenu ROUTINE                                     ! Code for menu items on ?EditMenu
Menu::BrowseMenu ROUTINE                                   ! Code for menu items on ?BrowseMenu
  CASE ACCEPTED()
  OF ?Browseaddress
    START(BrowseAddress, 050000)
  END
Menu::WindowMenu ROUTINE                                   ! Code for menu items on ?WindowMenu
Menu::HelpMenu ROUTINE                                     ! Code for menu items on ?HelpMenu

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Main')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = 1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.AddItem(Toolbar)
  SELF.Open(AppFrame)                                      ! Open window
  Do DefineListboxStyle
  INIMgr.Fetch('Main',AppFrame)                            ! Restore window settings from non-volatile store
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Main',AppFrame)                         ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Toolbar:Top
    OROF ?Toolbar:PageUp
    OROF ?Toolbar:Up
    OROF ?Toolbar:Locate
    OROF ?Toolbar:Down
    OROF ?Toolbar:PageDown
    OROF ?Toolbar:Bottom
    OROF ?Toolbar:Select
    OROF ?Toolbar:Insert
    OROF ?Toolbar:Change
    OROF ?Toolbar:Delete
    OROF ?Toolbar:History
    OROF ?Toolbar:Help
      IF SYSTEM{PROP:Active} <> THREAD()
        POST(EVENT:Accepted,ACCEPTED(),SYSTEM{Prop:Active} )
        CYCLE
      END
    ELSE
      DO Menu::FileMenu                                    ! Process menu items on ?FileMenu menu
      DO Menu::EditMenu                                    ! Process menu items on ?EditMenu menu
      DO Menu::BrowseMenu                                  ! Process menu items on ?BrowseMenu menu
      DO Menu::WindowMenu                                  ! Process menu items on ?WindowMenu menu
      DO Menu::HelpMenu                                    ! Process menu items on ?HelpMenu menu
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

