

   MEMBER('email.clw')                                     ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('EMAIL002.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('EMAIL004.INC'),ONCE        !Req'd for module callout resolution
                     END


BrowseAddress PROCEDURE                                    ! Generated from procedure template - Window

                INCLUDE('emaildef.inc', 'Defines')

! SendMail returns 0 on success
SUCCESS         EQUATE(0)

! How long to display the success/error message
MESSAGE_TIME    EQUATE(10)

! Used to time the message on the window
MessageCnt      LONG

! Used to hold the error number from sending the email
mError          ULONG
CurrentTab           STRING(80)                            !
FilesOpened          BYTE                                  !
MessageStr           STRING(30)                            !
MapiLogonUI          ULONG                                 !
MapiNewSession       STRING(20)                            !
MapiDialog           ULONG                                 !
ReturnRecip          ULONG                                 !
Flags                ULONG                                 !
BRW1::View:Browse    VIEW(address)
                       PROJECT(ADD:Name)
                       PROJECT(ADD:email)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
ADD:Name               LIKE(ADD:Name)                 !List box control field - type derived from field
ADD:email              LIKE(ADD:email)                !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Browse the address file'),AT(,,374,258),FONT('MS Sans Serif',8,,),IMM,HLP('Browseaddress'),TIMER(100),SYSTEM,GRAY,RESIZE,MDI
                       SHEET,AT(4,4,160,162),USE(?CurrentTab)
                         TAB('ADD:KeyName'),USE(?Tab:2)
                         END
                       END
                       LIST,AT(8,20,152,142),USE(?Browse:1),IMM,HVSCROLL,MSG('Browsing Records'),FORMAT('80L(2)|M~Name~L(2)@s30@80L(2)|M~email~L(2)@s50@'),FROM(Queue:Browse:1)
                       BUTTON('&Send'),AT(10,175,45,14),USE(?EmailBtn)
                       STRING(@s30),AT(10,196,147,10),USE(MessageStr),FONT(,,080FF80H,,CHARSET:ANSI)
                       STRING('If you find this useful, drop me a line.'),AT(10,213,165,13),USE(?String6),TRN
                       STRING('That''s my email address in the list.'),AT(10,220),USE(?String7),TRN
                       CHECK('Return Receipt'),AT(189,222),USE(ReturnRecip),VALUE('MAPI_RECEIPT_REQUESTED','')
                       STRING('This app and it''s code are not to be used for spam!'),AT(10,231),USE(?String8),FONT(,,COLOR:Red,,CHARSET:ANSI),COLOR(COLOR:Black)
                       CHECK('Logon UI'),AT(189,236),USE(MapiLogonUI),VALUE('1','')
                       CHECK('New Session'),AT(242,236),USE(MapiNewSession),VALUE('1','')
                       CHECK('Dialog'),AT(307,236),USE(MapiDialog),VALUE('1','')
                       BUTTON('&Insert'),AT(17,130,45,14),USE(?Insert:2),HIDE
                       BUTTON('Close'),AT(62,175,45,14),USE(?Close),HIDE
                       BUTTON('&Change'),AT(66,130,45,14),USE(?Change:2),HIDE,DEFAULT
                       BUTTON('Help'),AT(114,175,45,14),USE(?Help),HIDE,STD(STD:Help)
                       BUTTON('&Delete'),AT(115,130,45,14),USE(?Delete:2),HIDE
                       LINE,AT(176,1,0,250),USE(?Line1),COLOR(COLOR:Black)
                       STRING('From email'),AT(189,5),USE(?String4)
                       ENTRY(@s255),AT(189,16,175,10),USE(FromEmail)
                       STRING('Subject'),AT(189,28),USE(?String2)
                       ENTRY(@s49),AT(189,39,175,10),USE(MSG:Subject)
                       STRING('Body'),AT(189,55),USE(?String3)
                       TEXT,AT(189,66,175,118),USE(MSG:Body),BOXED
                       STRING('File to attach'),AT(189,192),USE(?String1)
                       ENTRY(@s127),AT(189,203,155,10),USE(MSG:FileToAttach)
                       BUTTON('...'),AT(349,202,12,12),USE(?LookupFile)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Kill                   PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED ! Method added to host embed code
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED       ! Method added to host embed code
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)                    ! Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Fetch                  PROCEDURE(BYTE Direction),DERIVED   ! Method added to host embed code
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM) ! Method added to host embed code
                     END

BRW1::Sort0:Locator  StepLocatorClass                      ! Default Locator
BRW1::Sort0:StepClass StepStringClass                      ! Default Step Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False) ! Method added to host embed code
                     END

FileLookup5          SelectFileClass

  CODE
? DEBUGHOOK(address:Record)
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It's called after the window open
!|
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseAddress')
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  SELF.AddItem(Toolbar)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  Relate:address.Open                                      ! File address used by this procedure, so make sure it's RelationManager is open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:address,SELF) ! Initialize the browse manager
  SELF.Open(QuickWindow)                                   ! Open window
  Do DefineListboxStyle
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime) ! Moveable thumb based upon ADD:Name for sort order 1
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,ADD:KeyName)     ! Add the sort order for ADD:KeyName for sort order 1
  BRW1.AddLocator(BRW1::Sort0:Locator)                     ! Browse has a locator for sort order 1
  BRW1::Sort0:Locator.Init(,ADD:Name,1,BRW1)               ! Initialize the browse locator using  using key: ADD:KeyName , ADD:Name
  BRW1.AddField(ADD:Name,BRW1.Q.ADD:Name)                  ! Field ADD:Name is a hot field or requires assignment from browse
  BRW1.AddField(ADD:email,BRW1.Q.ADD:email)                ! Field ADD:email is a hot field or requires assignment from browse
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)      ! Controls like list boxes will resize, whilst controls like buttons will move
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('BrowseAddress',QuickWindow)                ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  BRW1.AskProcedure = 1
  FileLookup5.Init
  FileLookup5.ClearOnCancel = True
  FileLookup5.Flags=BOR(FileLookup5.Flags,FILE:LongName)   ! Allow long filenames
  FileLookup5.SetMask('All Files','*.*')                   ! Set the file mask
  FileLookup5.AddMask('Clarion Source Files','*.clw')      ! Add additional masks
  FileLookup5.AddMask('Text Files','*.txt')                ! Add additional masks
  FileLookup5.WindowTitle='Attach File'
  BRW1.AddToolbarTarget(Toolbar)                           ! Browse accepts toolbar control
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:address.Close
  END
  IF SELF.Opened
    INIMgr.Update('BrowseAddress',QuickWindow)             ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled                         ! Always return RequestCancelled if the form was opened in ViewRecord mode
  ELSE
    GlobalRequest = Request
    UpdateAddress
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?EmailBtn
      ThisWindow.Update
      MessageStr = 'Sending message...'
      ?MessageStr{PROP:FontColor} = COLOR:Black
      DISPLAY(?MessageStr)
      
      ! Don't allow another Send until this one completes.
      DISABLE(?EmailBtn)
      
      ! Build the Flags based on the three session check boxes.
      Flags = 0
      IF MapiLogonUI THEN Flags += MAPI_LOGON_UI.
      IF MapiNewSession THEN Flags += MAPI_NEW_SESSION.
      IF MapiDialog THEN Flags += MAPI_DIALOG.
      
      ! Send the email
      mError = SendMail(ADD:email, MSG:Subject, MSG:Body, MSG:FileToAttach, ReturnRecip, Flags)
      
      ! Check for errors
      IF mError <> SUCCESS
      
          ! Display error message on the panel
          MessageStr = 'Error ' & mError
          ?MessageStr{PROP:FontColor} = COLOR:Red
          DISPLAY(?MessageStr)
          MessageCnt = MESSAGE_TIME
      
          ! Pop up and English error message
          MESSAGE(GetMapiErrorText(mError) & '|' & |
                    'Error number ' & mError, 'Mail delivery error')
      ELSE
      
          ! Display success on the panel
          MessageStr = 'Message has been sent'
          ?MessageStr{PROP:FontColor} = COLOR:Green
          DISPLAY(?MessageStr)
          MessageCnt = MESSAGE_TIME
      END
      
      ! Okay to send now, turn the button back on.
      ENABLE(?EmailBtn)
      
    OF ?LookupFile
      ThisWindow.Update
      MSG:FileToAttach = FileLookup5.Ask(1)
      DISPLAY
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all window specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF EVENT:Timer
      ! Time out the message displayed on the panel
      IF MessageCnt > 0
          MessageCnt -= 1
          IF MessageCnt <= 0
              MessageStr = ''
              DISPLAY(?MessageStr)
          END
      END
      
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Fetch PROCEDURE(BYTE Direction)

GreenBarIndex   LONG
  CODE
  PARENT.Fetch(Direction)


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord                              ! If called for anything other than ViewMode, make the insert, change & delete controls available
    SELF.InsertControl=?Insert:2
    SELF.ChangeControl=?Change:2
    SELF.DeleteControl=?Delete:2
  END


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults                                   ! Calculate default control parent-child relationships based upon their positions on the window

